
#include <functional>
#include <iostream>
#include <iomanip>
#include <cmath>
#include <random>
#include <typeinfo>
#include <type_traits>
#include <vector>

using std::cout;
using std::setw;
using std::ostream;
using std::vector;

struct fail {
   fail (char const * const m) 
      { cout << "\n\n *** fail *** " << m << " *** \n\n"; }   
};

//////////

#include "multicomplex_a.h"
#include "multicomplex_b.h"
#include "multicomplex_c.h"
#include "multicomplex_d.h"

// explicit instantiation aids static constants within
// the template classes, at least on some compilers
template class multicomplex<double,0>;
template class multicomplex<double,1>;
template class multicomplex<double,2>;
template class multicomplex<double,3>;
template class multicomplex<double,4>;
template class multicomplex<double,5>;

// these are convenient:
using mcd0 = multicomplex<double,0>;
using mcd1 = multicomplex<double,1>;
using mcd2 = multicomplex<double,2>;
using mcd3 = multicomplex<double,3>;
using mcd4 = multicomplex<double,4>;
using mcd5 = multicomplex<double,5>;

#include "flat.h"

using fd0 = flat<double,0>;
using fd1 = flat<double,1>;
using fd2 = flat<double,2>;
using fd3 = flat<double,3>;
using fd4 = flat<double,4>;
using fd5 = flat<double,5>;

#include "demo_a.h"
#include "demo_b.h"
#include "demo_c.h"
#include "demo_d.h"
#include "demo_e.h"

int main () {
    cout.setf (std::ios::fixed, std::ios::floatfield);
    cout.precision (4);

    format_demo (cout);
    unit_demo (cout);
    arith_demo<mcd2, mcd3, mcd0> (cout);
    arith_demo_rigorous (cout);
    transcend_demo_1 (cout);
    transcend_demo_2<4> (cout);
    transcend_demo_3 (cout);
    at_var_demo (cout);
    nesting_demo_1 (cout);
    nesting_demo_2 (cout);
    layout_demo (cout);
    flat_demo (cout);
    convert_demo (cout);
    
    std::cout << "\n\n";
    return 0;
}

