
template <typename elem, int order>
void multicomplex<elem,order>::view_i (ostream & o) const {
    o << "(";
    real.view_i (o);
    o << " ";
    if (order > 1) o << "+ ";
    imag.view_i (o);
    o << "*i" << order << ")";
}

template <typename elem>
void multicomplex<elem,0>::view_i (ostream & o) const {
    if (sole >= 0)
        o << "+ " << +sole;
    else
        o << "- " << -sole;
}

///////////////////////

template <typename elem, int order>
void multicomplex<elem,order>::view_j (
    ostream & o, int const sum
) const {
    real.view_j (o, sum);
    o << " ";
    imag.view_j (o, sum + off);
}

template <typename elem, int order>
void multicomplex<elem,order>::view_j (ostream & o) const {
    o << "(";
    view_j (o, 0);
    o << ")";
}

template <typename elem>
void multicomplex<elem,0>::view_j (
    ostream & o, int const sum
) const {
    if (sole >= 0)
        o << "+ " << +sole;
    else
        o << "- " << -sole;
    o << "*j" << sum;
}

template <typename elem>
void multicomplex<elem,0>::view_j (ostream & o) const {
    o << "(";
    view_j (o, 0);
    o << ")";
}

///////////////////////

template <typename elem, int order>
void multicomplex<elem,order>::view_k (ostream & o) const {
    o << "[";
    real.view_k (o);
    o << " ";
    imag.view_k (o);
    o << "]";
}

template <typename elem>
void multicomplex<elem,0>::view_k (ostream & o) const {
    o << sole;
}


