
/* Your compiler may want these declarations:

template <typename elem, int order>
multicomplex<elem,order> sin
    (multicomplex<elem,order> const &);

template <typename elem>
multicomplex<elem, 0> sin
    (multicomplex<elem,0> const &);

template <typename elem, int order>
multicomplex<elem,order> sinh
    (multicomplex<elem,order> const &);

template <typename elem>
multicomplex<elem, 0> sinh
    (multicomplex<elem,0> const &);

template <typename elem, int order>
multicomplex<elem,order> cos
    (multicomplex<elem,order> const &);

template <typename elem>
multicomplex<elem, 0> cos
    (multicomplex<elem,0> const &);

template <typename elem, int order>
multicomplex<elem,order> cosh
    (multicomplex<elem,order> const &);

template <typename elem>
multicomplex<elem, 0> cosh
    (multicomplex<elem,0> const &);

template <typename elem, int order>
multicomplex<elem,order> exp
    (multicomplex<elem,order> const &);

template <typename elem>
multicomplex<elem, 0> exp
    (multicomplex<elem,0> const &);

*/

template <typename elem, int order>
multicomplex<elem,order> sin (multicomplex<elem,order> const & z) {
    return multicomplex<elem,order> {
        sin (z.real) * cosh (z.imag),
        cos (z.real) * sinh (z.imag)
    };
}

template <typename elem>
multicomplex<elem, 0> sin (multicomplex<elem,0> const & z) {
    return multicomplex<elem,0> {sin (z.sole)};
}

template <typename elem, int order>
multicomplex<elem,order> sinh (multicomplex<elem,order> const & z) {
    return multicomplex<elem,order> {
        sinh (z.real) * cos (z.imag),
        cosh (z.real) * sin (z.imag)
    };
}

template <typename elem>
multicomplex<elem, 0> sinh (multicomplex<elem,0> const & z) {
    return multicomplex<elem,0> {sinh (z.sole)};
}

template <typename elem, int order>
multicomplex<elem,order> cos (multicomplex<elem,order> const & z) {
    return multicomplex<elem,order> {
        + cos (z.real) * cosh (z.imag),
        - sin (z.real) * sinh (z.imag)
    };
}

template <typename elem>
multicomplex<elem, 0> cos (multicomplex<elem,0> const & z) {
    return cos (z.sole);
}

template <typename elem, int order>
multicomplex<elem,order> cosh (multicomplex<elem,order> const & z) {
    return multicomplex<elem,order> {
        cosh (z.real) * cos (z.imag),
        sinh (z.real) * sin (z.imag)
    };
}

template <typename elem>
multicomplex<elem, 0> cosh (multicomplex<elem,0> const & z) {
    return cosh (z.sole);
}

template <typename elem, int order>
multicomplex<elem,order> exp (multicomplex<elem,order> const & z) {
    multicomplex<elem,order-1> const r {exp (z.real)};
    return multicomplex<elem,order> {
        r * cos (z.imag),
        r * sin (z.imag)
    };
}

template <typename elem>
multicomplex<elem, 0> exp (multicomplex<elem,0> const & z) {
    return exp (z.sole);
}


